Subject: bug#68851: 30.0.50; Native comp: Optimization failure for org-element-property-raw: Handler: org-element-property-raw--inliner

From: Andrea Corallo <[email-masked]>
Date: Fri, 02 Feb 2024 04:00:13 -0500

Eli Zaretskii <[email-masked]> writes:

>> Cc: Stefan Monnier <[email-masked]>
>> From: Ihor Radchenko <[email-masked]>
>> Date: Wed, 31 Jan 2024 13:50:42 +0000
>> 
>> I just stumbled upon strange native compiler warning after defining the
>> following inliner:
>> 
>> (define-inline org-element--property-idx (property)
>>   "Return standard property index or nil."
>>   (declare (pure t))
>>   (inline-letevals (property)
>>     (plist-get
>>      org-element--standard-properties-idxs
>>      (inline-const-val property))))
>> 
>> ⛔ Warning (comp): Warning: Optimization failure for org-element-property-raw: Handler: org-element-property-raw--inliner
>> 
>> This is on the latest Org mode main branch.
>> 
>> This looks like a bug unless I misunderstand something about inlined functions.
>
> Andrea, can you please help understand this warning?
>
>> 
>> ⛔ Warning (comp): Warning: Optimization failure for org-element-property-raw: Handler: org-element-property-raw--inliner
>> ⛔ Warning (comp): Warning: Optimization failure for org-element-put-property: Handler: org-element-put-property--inliner
>> ⛔ Warning (comp): Warning: Optimization failure for org-element-property-raw: Handler: org-element-property-raw--inliner
>> ⛔ Warning (comp): Warning: Optimization failure for org-element-put-property: Handler: org-element-put-property--inliner
>> ⛔ Warning (comp): Warning: Optimization failure for org-element-put-property: Handler: org-element-put-property--inliner
>> ⛔ Warning (comp): Warning: Optimization failure for org-element-property: Handler: org-element-property--inliner
>> ⛔ Warning (comp): Warning: Optimization failure for org-element-put-property: Handler: org-element-put-property--inliner
>> ⛔ Warning (comp): Warning: Optimization failure for org-element-put-property: Handler: org-element-put-property--inliner
>> ⛔ Warning (comp): Warning: Optimization failure for org-element-property: Handler: org-element-property--inliner
>> ⛔ Warning (comp): Warning: Optimization failure for org-element-put-property: Handler: org-element-put-property--inliner
>> ⛔ Warning (comp): Warning: Optimization failure for org-element-put-property: Handler: org-element-put-property--inliner
>> ⛔ Warning (comp): Warning: Optimization failure for org-element-put-property: Handler: org-element-put-property--inliner
>> ⛔ Warning (comp): Warning: Optimization failure for org-element-put-property: Handler: org-element-put-property--inliner
>> ⛔ Warning (comp): Warning: Optimization failure for org-element-put-property: Handler: org-element-put-property--inliner
>> ⛔ Warning (comp): Warning: Optimization failure for org-element-put-property: Handler: org-element-put-property--inliner

Hi, I can't investigate this directly before next week but I was
wondering:

Ihor have you tried compiling the compilation unit from command line
(using batch-byte-compile or batch-native-compile)?  If some dependency
is broken this should highlight it.

Thanks

  Andrea